# This code is copyrighted by bluedynamics.com in September, 2001.
#
# written by Stephan Richter
# Last updated: September 3, 2001

from General import getSubObjectClass
from Globals import DTMLFile

class DBObjectSearchSupport:

    searchableAttributes = ()



_qry_searchTable = '''
SELECT id, containerid, containertype, '&dtml-table;' as metatype
FROM &dtml-table;
WHERE
  <dtml-in attributes>
    &dtml-sequence-item; *~ <dtml-sqlvar searchString type="string"> OR 
  </dtml-in>
  1 = 0
'''


class DBObjectFolderSearchSupport:

    manage_options    = ({'label':'Search', 'action':'manage_searchForm'},)
    manage_searchForm = DTMLFile('dtml/manage_searchForm', globals())
    manage_search     = DTMLFile('dtml/manage_search', globals())

    sqlMethods = ( ('qry_searchTable', 'table attributes:list searchString',  _qry_searchTable),)

    def _findAllSubObjectClasses(self):
        ''' '''

        metaTypes = list(self.allowedSubObjects)
        objects = []

        while metaTypes:

            metaType = metaTypes.pop()
            object = getSubObjectClass(metaType)

            if hasattr(object, 'allowedSubObjects'):
                for metatype in object.allowedSubObjects:
                    if metatype not in map(lambda x: x.meta_type, objects):
                        metaTypes.append(metatype)

            if hasattr(object, 'searchableAttributes'):
                objects.append(object)

        return objects

        
    def search(self, searchString):
        ''' '''
        result = []
        for object in self._findAllSubObjectClasses():
            dbRows = self.qry_searchTable(table=object.meta_type,
                                          attributes=object.searchableAttributes,
                                          searchString=searchString)

            for row in dbRows:
                try:
                    object = self.getObjectTreeWithSQL(self, [row.id, row.metatype+'s', ],
                                                       row.containertype, row.containerid)
                    object.setTemporaryAttributes(row)
                    result.append(object)
                except KeyError:
                    pass

        return result

    
