# This code is copyrighted by iuveno AG in June, 2001.
#
# written by Stephan Richter
# Last updated: June 6, 2001

import string, os
from Globals import package_home

_marker = []

if not hasattr(globals(), 'registeredProducts'):
    registeredProducts = ()


def registerProduct(productName):
    '''register a product as being a DBObjects product. This way we can
       find the classes by the meta type more easily later; return None'''
    global registeredProducts
    if productName not in registeredProducts: 
        registeredProducts = registeredProducts + (productName,)



def getSubObjectClass(metaType):
    '''getSubObjectClass(metaType) --> get class of sub-object with meta type; return class'''
    moduleName = metaType
    moduleName = string.replace(moduleName, 'Folder', '')
    for product in registeredProducts:
        try:
            exec "from Products.%s.%s import %s" %(product, moduleName, metaType)
            return eval(metaType)
        except ImportError:
            pass
        
    return getSubObjectClassSystematically(metaType)



def getSubObjectClassSystematically(metaType):
    '''getSubObjectClassSystematically(metaType) --> '''
    # prepare the module
    dirString = string.replace(package_home(globals()), '\\', '/')
    dirs = string.split(dirString, '/')
    for dir in list(dirs):
        if dir != 'Products': dirs.remove(dir)
        else: break

    modulePath = string.join(dirs, '.')

    for pyFile in os.listdir(package_home(globals())):
        if pyFile[-2:] == 'py':
            try:
                exec "from %s import %s" %(modulePath + '.' + pyFile[:-3], metaType)
                return eval(metaType)
            except ImportError:
                pass

    raise 'NotFoundError', "BAD! The Class with the meta-type '%s' was not found." %metaType


def canStringBeInt(string):
    '''canStringBeInt(string) --> check whether the string can be converted to an int;
       return boolean'''
    try:
         int(string)
         return 1
    except ValueError:
        return 0








