# This code is copyrighted by iuveno AG in January, 2001.
#
# written by Stephan Richter
# Last updated: March 17, 2001

# Note: These classes are a small extension to the TreeViewSupport classes, so that the trees
#       can also be displayed in a nice flat list.

import string


class FlatTreeViewSupportObject:
    '''FlatTreeViewSupportObject class - adds support for displaying an object tree as a flat list'''
    
    pass


_qry_getObjectsByIdList = '''
SELECT *
  FROM <dtml-var table>
  WHERE id in (<dtml-var idList>) 
  ORDER BY <dtml-var orderBy>
'''

class FlatTreeViewSupportFolder:
    '''TreeViewSupportObject class - adds support for displaying an object tree as a flat list'''

    sqlMethods = (('qry_getObjectsByIdList', 'table idList orderBy', _qry_getObjectsByIdList),)
  

    def getObjectsByIdList(self, ids, orderBy):
        '''getObjectsByIdList(self, ids) --> get DB entries for the objects that are lists id ids;
           return list of DBObjects'''
        tableName = string.replace(self.meta_type, 'Folder', '')
        ids = string.join(ids, ', ')
        
        container = self._getSQLMethodContainer(self)
        return container.qry_getObjectsByIdList(table=tableName, idList=ids, orderBy=orderBy)


    def getAllObjectsFromSubTree(self):
        '''getAllObjectsFromSubTree(self) --> makes a flat list of the object tree; return list of dbRows'''

        localObjects = self.objectValues()
        # make a copy of localObjects; that's why we use the map() function  
        allObjects = map(lambda x: x, localObjects)

        for object in localObjects:
            if hasattr(object, object.meta_type+'s'):
                allObjects = allObjects + object[object.meta_type+'s'].getAllObjectsFromSubTree()

        return allObjects


    def getFlatListOfTree(self, orderBy='id'):
        '''getFlatListOfTree(self, orderBy="id") --> get a flat list of all the elements in the tree;
           return DB Rows with special object attribute!!!'''

        ids = map(lambda x: x.id, self.getAllObjectsFromSubTree())
        return self.getObjectsByIdList(ids, orderBy)






