# This code is copyrighted by iuveno AG in January, 2001.
#
# written by Stephan Richter
# Last updated: February 4, 2001

import os

class TreeViewSupportObject:
    '''TreeViewSupportObject class - adds support for displaying an object tree as a DTML-Tree'''

    def getTotalPathOfTree(self):
        '''getTotalPathOfTree(self) --> get the path of the entire tree; return string'''
        return os.path.join(self.aq_parent.getTotalPathOfTree(), self.id)


    def getPathToNode(self, node):
        '''getPathToNode(self, node) --> get the path to a specific object; return string '''
        return os.path.join(self.aq_parent.getPathToNode(node), self.id)
    

    def getTreeSubObjects(self):
        '''getTreeSubObjects(self) --> a method that returns the subobjects of this task; return list'''
        if self.meta_type+'s' in self.objectIds():
            return self[self.meta_type+'s'].tpValues()
        else:
            return []



class TreeViewSupportFolder:
    '''TreeViewSupportObject class - adds support for displaying an object tree as a DTML-Tree'''

    treeRoot = 0

    def setTreeRoot(self, isTreeRoot=1):
        '''setTreeRoot(isTreeRoot=1) --> set this object to be the root of the tree'''
        self.treeRoot = isTreeRoot
        

    def getPathToNode(self, node):
        '''getPathToNode(self, node) --> get the path to a specific object; return string '''

        if node == self:
            return self.id
        else:
            return os.path.join(self.aq_parent.getPathToNode(node), self.id)


    def getTotalPathOfTree(self):
        '''getTotalPathOfTree(self) --> get the path of the entire tree; treeRoot must be set; return string'''
        if hasattr(self, 'treeRoot') and self.treeRoot:
            return self.id
        else:
            return os.path.join(self.aq_parent.getTotalPathOfTree(), self.id)


    def getTreeSubObjects(self):
        '''getTreeSubObjects(self) --> a method that returns the subobjects of this task; return list'''
        return self.tpValues()
